subroutine bc2 ( maxmx, maxmy, meqn, mbc, mx, my, x_low, y_low, &
                 dx, dy, q, maux, aux, t, dt, mthbc )

!-----------------------------------------------------------
! Extends the data for each component of q into ghost cells
! by performing even extensions about the boundary.
!-----------------------------------------------------------


    implicit none


    !==== Variables ====
    
    !---- Inputs ----
    integer, intent(in) :: maxmx, maxmy, meqn, mbc, mx, my, maux
    double precision, intent(in) :: x_low, y_low, dx, dy, t, dt
    double precision :: aux(1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc, maux)
    integer ::  mthbc(4)

    !---- In/out ----
    double precision :: q(1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc, meqn)
    
    !---- External ----
    double precision, external :: film_true, surfactant_true

    



    call fill_ghost_cells( q(:,:,1), film_true,       t, x_low, y_low, dx, dy, mx, my, mbc )
    call fill_ghost_cells( q(:,:,2), surfactant_true, t, x_low, y_low, dx, dy, mx, my, mbc )


end subroutine bc2
