subroutine qinit( maxmx, maxmy, meqn, mbc, mx, my, x_low, y_low, dx, dy, q )

!---------------------------------------------------------
! Sets initial data for axisymmetric similarity solution.
!---------------------------------------------------------


    implicit none


    !==== Variables ====
        
	!---- Globals ----
	double precision ::  beta, kappa, mu, delta
	common /param_block/ beta, kappa, mu, delta

    !---- Inputs ----
    integer, intent(in) :: maxmx, maxmy, meqn, mbc, mx, my
    double precision, intent(in) :: x_low, y_low, dx, dy

    !---- Outputs ----
    double precision, intent(out) :: q(1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc, meqn)

    !---- Locals ----
    integer :: ix, iy
    double precision :: x, y
    
    !---- External ----
    double precision, external :: film_true, surfactant_true



    do iy = 1, my
        
        y = y_low + (iy-.5d0)*dy
        
        do ix = 1, mx
            
            x = x_low + (ix-.5d0)*dx
            
            q(ix,iy,1) = film_true( x, y, 0.d0 )
            q(ix,iy,2) = surfactant_true( x, y, 0.d0 )

        end do

	end do

    print *, q(mx,my,1)

    
end subroutine qinit