subroutine setprob

!===> Description ===>
!
! This routine reads input parameters from setprob.data (which is
! generated by setrun.py), and stores them in their respective common
! blocks.
!
!<=== Description <===



!===> Variables ===>
    implicit none
    !---- Globals ----
    integer :: nthreads, newton_max_iter
    double precision :: beta, kappa, mu, delta, newton_reduction_factor
    common /param_block/  beta, kappa, mu, delta
    common /omp_block/    nthreads
    common /newton_block/ newton_max_iter, newton_reduction_factor
    !---- Locals ----
    character*12 fname
    integer :: iunit
!<=== Variables <===

      

!===> Open setprob.data ===>
    iunit = 7
    fname = 'setprob.data'
    call opendatafile(iunit, fname)
!<=== Open setprob.data <===



!===> Read in parameters ===>
    read(iunit,*) beta
    read(iunit,*) kappa
    read(iunit,*) mu
    read(iunit,*) delta
    read(iunit,*) nthreads
    read(iunit,*) newton_max_iter
    read(iunit,*) newton_reduction_factor
!<=== Read in parameters <===


    return
end subroutine setprob
