subroutine fill_ghost_cells ( q, q_true, t, x_low, y_low, dx, dy, mx, my, mbc )

    implicit none
    
    
    !==== Variables ====
    
    !---- Input ----
    integer, intent(in) :: mx, my, mbc
    double precision, intent(in) :: x_low, y_low, dx, dy, t

    !---- In/out ----
    double precision, intent(inout) :: q(1-mbc:mx+mbc, 1-mbc:my+mbc)
    
    !---- Locals ----
    integer :: ix, iy
    double precision :: x_coordinate, y_coordinate, x, y
    
    !---- External routines ----
    double precision, external :: q_true, film_true
    
    
    !==== Statement functions ====
    x_coordinate(ix) = x_low + (ix-.5d0)*dx
    y_coordinate(iy) = y_low + (iy-.5d0)*dy
    
    
    
    !---- Lower boundary (corners included) ----
    do iy = 1-mbc, 0
        
        y = y_coordinate(iy)
        
        do ix = 1-mbc, mx+mbc

            x = x_coordinate(ix)
            q(ix,iy) = q_true(x,y,t)
            
        end do
        
    end do
    
    
    
    
    !---- Left boundary ----
    do iy = 1, my
        
        y = y_coordinate(iy)
        
        do ix = 1-mbc, 0

            x = x_coordinate(ix)
            q(ix,iy) = q_true(x,y,t)
            
        end do
        
    end do
    
    
    
    !---- Right boundary ----
    do iy = 1, my
        
        y = y_coordinate(iy)
        
        do ix = mx+1, mx+mbc

            x = x_coordinate(ix)
            q(ix,iy) = q_true(x,y,t)
            
        end do
        
    end do
    
    
    
    !---- Top boundary (corners included) ----
    do iy = my+1, my+mbc
        
        y = y_coordinate(iy)
        
        do ix = 1-mbc, mx+mbc

            x = x_coordinate(ix)
            q(ix,iy) = q_true(x,y,t)
            
        end do
        
    end do
    
    
    

    
end subroutine fill_ghost_cells

