double precision function film_true ( x, y, t )
    implicit none
    double precision, intent(in) :: x, y, t
    double precision :: r, t0=4.1d0, tau
    
    tau = t + t0
    
    r = sqrt(x**2 + y**2)
    film_true = 2.d0 * (r / tau**.25d0)**2
    
end function film_true


double precision function surfactant_true ( x, y, t )
    implicit none
    double precision, intent(in) :: x, y, t
    double precision :: r, t0=4.1d0, tau
    
    tau = t+t0
    
    r = sqrt(x**2 + y**2)
    surfactant_true = -1.d0/(8.d0*sqrt(tau)) * log(r/tau**.25d0)


end function surfactant_true