subroutine write_numerical_error( q, q_true, t, x_low, y_low, dx, dy, mx, my, mbc )

    implicit none
    
    !==== Variables ====
    
    !---- Input ----
    integer, intent(in) :: mx, my, mbc
    double precision, intent(in) :: q(1-mbc:mx+mbc,1-mbc:my+mbc), x_low, y_low, dx, dy, t
    double precision, external :: q_true
    
    !---- Local ----
    double precision :: error_value, x, x_coordinate, y, y_coordinate, new_error
    integer :: ix, iy
        
    
    !==== Statement functions ====
    x_coordinate(ix) = x_low + (ix-.5d0)*dx
    y_coordinate(iy) = y_low + (iy-.5d0)*dy
    
    
    !===> Compute and write error ===>
    error_value = 0.d0

    do iy = 1, my
        
        y = y_coordinate(iy)
        
        do ix = 1, mx
            
            x = x_coordinate(ix)
            
!             new_error = abs( q(ix,iy) - q_true(x,y,t))
!             
!             if (new_error > error_value) then
!                 error_value = new_error
!                 print *, "inidces:    ", ix, iy
!                 print *, "coordinate: ", x, y
!                 print *, "values:     ", q(ix,iy), q_true(x,y,t)
!             end if
            
            error_value = max(error_value, abs( q(ix,iy) - q_true(x,y,t)) )

        end do
    end do

    open( unit=11, file="error_value.txt" )
    write(11, *) error_value
    close( 11 )
    !<=== Compute and write error <===
    


end subroutine write_numerical_error