from numpy import *
import pylab
from ClawSolution1D import ClawSolution1D
import os


# t0 = .3
# a  = 4.5**(1./3.)
# 
# def qTrue( x, t ):
# 
#     tau = t + t0
#     y1 = 1./(6*tau) * ( (a * tau**(1./3.))**2 - x**2 )
#     y2 = zeros( shape(x) )
#     
#     return where( abs(x) <= a*tau**(1./3.), y1, y2 )
#     # return y1
#     


plot_parameters = {'backend': 'eps',
          'lines.linewidth': 2,
          'lines.markersize': 4,
          'text.fontsize': 10,
          'font.size'    : 10,
          'legend.fontsize': 10,
          'xtick.labelsize': 10,
          'ytick.labelsize': 10,
          'axes.labelsize':  14,
          'figure.subplot.left':   0.15,
          'figure.subplot.right':  0.95,
          'figure.subplot.bottom': 0.15,
          'figure.subplot.top':    0.9}

pylab.rcParams.update(plot_parameters)

pylab.figure(figsize=(4,3), facecolor='w', edgecolor='k')



claw_sol = ClawSolution1D('_output', 0)
pylab.plot(claw_sol.x(), claw_sol.q[:,0], 'ko', label='$t=0$')


claw_sol.setFrame(20)
pylab.plot(claw_sol.x(), claw_sol.q[:,0], 'k-+', label='$t=6$')



# x_fine = linspace(claw_sol.x_low, claw_sol.x_high, 301)
# pylab.plot( x_fine, qTrue(x_fine, claw_sol.t), 'k-', label='True' )
# pylab.xlim(-0.,2)
pylab.ylim(-.2,2.2)
pylab.xlabel('$x$')
# pylab.title('$t_{\rm final}=0.8$, $t_0=0.3$')


pylab.legend()


# pylab.savefig('/Users/onath/Documents/Projects/Surfactant/surfactant_paper/paper/figures/KdVSnapshot.eps')
