
subroutine bc1(maxmx, meqn, mbc, mx, x_low, dx, q, maux, aux, t, dt, mthbc)

    implicit none
    
    !==== Variables ====
    
    !---- Inputs ----
    integer, intent(in) :: maxmx, meqn, mbc, mx, mthbc(2), maux
    double precision, intent(in) :: x_low, dx, aux, t, dt
    
    !---- Input/output ----
    double precision, intent(inout) :: q(1-mbc:mx+mbc,meqn)
    
    !---- Functions ----
    double precision :: q_true
    
    !---- Locals ----
    double precision :: x_coordinate
    integer :: i


    !==== Statement functions ====
    x_coordinate(i) = x_low + (i-.5d0)*dx


    !==== Apply true solution ====
    !-------------------------------------------------------------------
    ! This only uses the first layer of ghost cells, as I'm not
    ! doing anything with limiters.  But I'm leaving the loop structure
    ! just in case.
    !-------------------------------------------------------------------
    
    
    do i = 0,0
        q(i,1) = q_true( x_coordinate(i), t )
    end do
    
    do i = mx+1,mx+1
        q(i,1) = q_true( x_coordinate(i), t )
    end do

    



end subroutine bc1
