subroutine write_numerical_error( q, x_low, dx, t, mx, mbc, meqn )

    implicit none
    
    !==== Variables ====
    
    !---- Input ----
    integer, intent(in) :: mx, mbc, meqn
    double precision, intent(in) :: q(1-mbc:mx+mbc,meqn), x_low, dx, t

    !---- Function ----
    double precision :: q_true
    
    !---- Local ----
    double precision :: error_value, x, x_coordinate
    integer :: i
    
    
    !==== Statement functions ====
    x_coordinate(i) = x_low + (i-.5d0)*dx
    
    
    !===> Compute and write error ===>
    error_value = 0.d0
    do i = 1,mx
        x = x_coordinate(i)
        error_value = max(error_value, abs(q(i,1) - q_true(x,t)))
!         print *, i, x, q(i,1), q_true(x,t)
    end do

    open( unit=11, file="error_value.txt" )
    write(11, *) error_value
    close( 11 )
    !<=== Compute and write error <===
    


end subroutine write_numerical_error