subroutine qinit(maxmx,meqn,mbc,mx,x_low,dx,q,maux,aux)

    implicit none

    !==== Variables ====
    
    !---- Input ----
    integer, intent(in) :: maxmx, meqn, mbc, mx, maux
    double precision :: x_low, dx, aux
    
    !---- Output ----
    double precision, intent(out) :: q(1-mbc:mx+mbc,meqn)

    
    !---- Local ----
    double precision :: x, q_true
    integer :: i
    
    
    do i = 1,mx
        x      = x_low + (i-0.5d0)*dx
        q(i,1) = q_true(x, 0.d0)
    end do
    
    
    q(:,2) = q(:,1)

end subroutine qinit



function q_true( x, t )
    double precision, intent(in) :: x, t
    double precision :: q_true
    double precision :: t0=.3d0, tau, one_third
    parameter( one_third = 1.d0/3.d0 )
    double precision :: a=(4.5d0)**one_third

    tau = t + t0


    if (abs(x) <= a*tau**one_third) then
        q_true = 1.d0/(6*tau) * ( (a * tau**one_third)**2 - x**2 )
    else
        q_true = 0.d0
    end if
    
end function q_true