program driver
!---> Description --->
!
! This is a driver for a 2d Clawpack routine that allocates memory
! for q, aux, work, and mthlim based on the size information provided
! in claw.data.  This removes the need to manually edit the driver
! file based on problem size.
!
!<--- Description <---


!---> Variables --->
    character :: skipme
    integer :: maxmx, maxmy, maxm, meqn, mwaves, mbc, maux, mwork
    double precision, dimension(:,:,:), allocatable :: q, aux
    double precision, dimension(:), allocatable :: work
    integer, dimension(:), allocatable :: mthlim
!<--- Variables <---


!---> Read size info from claw.data --->
    call opendatafile(55,'claw.data')
    read(55,*) skipme
    
    read(55,*) maxmx
    read(55,*) maxmy

    do i=1,14
        read(55,*) skipme
    end do

    read(55,*) maux
    read(55,*) meqn
    read(55,*) mwaves

    do i=1,6
        read(55,*) skipme
    end do

    read(55,*) mbc

    close(55)
!<--- Read size info from claw.data <---


!---> Allocate memory --->
    allocate(q(1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc, meqn))

    if (maux>0) then
        allocate(aux(1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc, maux))
    else
        allocate(aux(1,1,1))
    end if
    
    allocate(mthlim(mwaves))
    
    maxm = max0(maxmx,maxmy)
    print *, "maxm = ", maxm
    mwork = (maxm+2*mbc)*(10*meqn + mwaves + meqn*mwaves + 3*maux + 2)    &
             + 2 * (maxmx + 2*mbc) * (maxmy + 2*mbc) * meqn
                          
    allocate(work(mwork))    
!<--- Allocate memory <---    


!---> Call claw2ez --->
    call claw2ez(maxmx,maxmy,meqn,mwaves,mbc,maux,mwork,mthlim,q,work,aux)
!<--- Call claw2ez <---

    stop 
end program driver
