clear all
clc

nx = 100;
x_low = 0.0;
x_high = 1.0;
dx = (x_high - x_low) / nx;

x = (x_low+dx/2:dx:x_high-dx/2)';
coordinate = @(ix) x_low + (ix-.5)*dx;



q = zeros(nx,1);


diffusivity = 5e-2;
courant = 0.9;
dt = courant * dx^2 / diffusivity;

t_final = 1.0;

t0 = .3;
q_true = @(x,t) 1/sqrt(4*pi*diffusivity*(t+t0)) * exp(-(x-.5).^2 / (4*diffusivity*(t+t0)) );



t = 0.0;
q = q_true(x, 0);


A = backwardEulerMatrix(courant, nx);


plot(x, q)
pause(1)


while (abs(t < t_final) > 1e-8)
    if (t + dt > t_final)
        dt = t_final - t;
    end
    
    rhs     = q;
    rhs(1)  = courant * q_true( coordinate(0),  t+dt );
    rhs(nx) = courant * q_true( coordinate(nx), t+dt );

    q = A\rhs;
    
    plot(x, q)
    pause(.1)
    
    t = t + dt;

    
end

