clear all
clc

nx = 9;
x_low = 0.0;
x_high = 1.0;
dx = (x_high - x_low) / nx;

x = x_low+dx/2:dx:x_high-dx/2;
coordinate = @(ix) x_low + (ix-.5)*dx;



q = zeros(nx+1,1);


velocity = 1.0;
courant = 0.9;
dt = courant * dx / velocity;

t_final = 1.0;

q_true = @(x,t) exp(-100*(x-velocity*t-.2).^2);



t = 0.0;
q(2:end) = q_true(x, 0);

e = ones(nx+1,1);
A = spdiags( [courant*e, (1-courant)*e], -1:0, nx+1, nx+1 );


while (abs(t < t_final) > 1e-8)
    if (t + dt > t_final)
        dt = t_final - t;
    end
    t = t + dt;
    
    q(1) = q_true(coordinate(0), t);
    q = A*q;
    
    plot(x, q(2:end))
    pause(.05)
    
end

A_upwind = full(A);