subroutine cn_cn_split ( q, final_bcs, diffusivity, dx, dt, mx )

    implicit none
    
    !==== Variables ====
    integer, intent(in) :: mx
    double precision, intent(in) :: final_bcs(2), diffusivity, dx, dt
    
    double precision, intent(inout) :: q(0:mx+1)
    
    double precision :: mid_bcs(2), old_bcs(2)
    
    
    !---- First stage ----
    
    old_bcs(1) = q(0)
    old_bcs(2) = q(mx+1)
    
    call diffusion_forward_estimate( mid_bcs, q(1:mx), old_bcs, diffusivity, dx, dt/2, mx )
    
    call crank_nicolson_1d( q(0:mx+1), mid_bcs, diffusivity, dx, dt/2, mx )    



    !---- Second stage ----

    call advdiff_backward_estimate( mid_bcs, q(1:mx), final_bcs, 0.d0, diffusivity, dx, dt/2, mx )

    q(0)    = mid_bcs(1)
    q(mx+1) = mid_bcs(2)

    call crank_nicolson_1d( q(0:mx+1), final_bcs, diffusivity, dx, dt/2, mx )    
    
    
    

    
end subroutine cn_cn_split