subroutine cn_lw_split ( q, final_bcs, velocity, diffusivity, dx, dt, mx )

    implicit none
    
    !==== Variables ====
    integer, intent(in) :: mx
    double precision, intent(in) :: final_bcs(2), velocity, diffusivity, dx, dt
    
    double precision, intent(inout) :: q(0:mx+1)
    
    double precision :: old_bcs(2), mid_bcs(2), init_bcs(2)
    

    init_bcs = (/ q(0), q(mx+1) /)

    
    !---- First stage ----
    
        
    call advdiff_backward_estimate( old_bcs, q(1:mx), final_bcs, velocity, diffusivity, dx, dt, mx )
    call diffusion_forward_estimate( mid_bcs, q(1:mx), old_bcs, diffusivity, dx, dt, mx )

    q(0)    = old_bcs(1)
    q(mx+1) = old_bcs(2)

    call crank_nicolson_1d( q(0:mx+1), mid_bcs, diffusivity, dx, dt, mx )    
        
        



    !---- Second stage ----

    call advdiff_backward_estimate( mid_bcs, q(1:mx), final_bcs, velocity, 0.d0, dx, dt, mx )

    q(0)    = mid_bcs(1)
    q(mx+1) = mid_bcs(2)


    call lax_wendroff_1d( q(0:mx+1), velocity, dx, dt, mx )    


    
    
end subroutine cn_lw_split