subroutine crank_nicolson_1d_split ( q, diffusivity, x_low, dx, t, dt, mx )

    implicit none
    
    !==== Variables ====
    integer, intent(in) :: mx
    double precision, intent(in) :: diffusivity, x_low, dx, t, dt
    double precision, intent(inout) :: q(0:mx+1)
    integer :: ix
    double precision :: q_true, coordinate, new_bcs(2)
    double precision :: q_left_new, q_left_temp
    
    
    !==== Statement function ====
    coordinate(ix) = x_low + (ix-0.5d0) * dx
    
    
    
    q(0)    = q_true( coordinate(0), t )
    q(mx+1) = q_true( coordinate(mx+1), t )
    
    q_left_new = q_true( coordinate(0), t+dt )
    q_left_temp = (q_left_new - diffusivity*dt/dx**2  * (-5*q(1) + 4*q(2) - q(3)))  &
                    /  (1.d0 + 2*diffusivity*dt/dx**2)
    new_bcs(1) = q_left_temp + diffusivity*dt/2/dx**2 * (2*q_left_temp -5*q(1) + 4*q(2) - q(3))    
    new_bcs(2) = q_true( coordinate(mx+1), t+dt/2 )
    
    call crank_nicolson_1d ( q, new_bcs, diffusivity, dx, dt/2, mx )
        
    new_bcs(1) = q_true( coordinate(0),    t+dt )
    new_bcs(2) = q_true( coordinate(mx+1), t+dt )
    
    call crank_nicolson_1d ( q, new_bcs, diffusivity, dx, dt/2, mx )
    
    
    
end subroutine crank_nicolson_1d_split