subroutine lw_cn_split ( q, final_bcs, velocity, diffusivity, dx, dt, mx )

    implicit none
    
    !==== Variables ====
    integer, intent(in) :: mx
    double precision, intent(in) :: final_bcs(2), velocity, diffusivity, dx, dt
    
    double precision, intent(inout) :: q(0:mx+1)
    
    double precision :: mid_bcs(2)
    
    
    !---- First stage ----
        
    call lax_wendroff_1d( q(0:mx+1), velocity, dx, dt, mx )    



    !---- Second stage ----

    call advdiff_backward_estimate( mid_bcs, q(1:mx), final_bcs, 0.d0, diffusivity, dx, dt, mx )

    q(0)    = mid_bcs(1)
    q(mx+1) = mid_bcs(2)

    call crank_nicolson_1d( q(0:mx+1), final_bcs, diffusivity, dx, dt, mx )    
    
    
end subroutine lw_cn_split