subroutine lw_lw_split ( q, new_bcs, velocity, dx, dt, mx )

    implicit none
    
    !==== Variables ====
    integer, intent(in) :: mx
    double precision, intent(in) :: new_bcs(2), velocity, dx, dt
    double precision, intent(inout) :: q(0:mx+1)
    double precision :: mid_bcs(2)
    
    
    
    !---- First advection step ----
    
    call lax_wendroff_1d( q(0:mx+1), velocity, dx, dt/2, mx )
    
    
    
    !---- Estimate BCs for next stage ----
    
    call advdiff_backward_estimate( mid_bcs, q(1:mx), new_bcs, velocity, 0.d0, dx, dt/2, mx )
    
    
    
    !---- Second advection step ----

    if (velocity>0.d0) then
        q(0) = mid_bcs(1)
    else
        q(mx+1) = mid_bcs(2)
    end if  

    call lax_wendroff_1d( q(0:mx+1), velocity, dx, dt/2, mx )
    
    
end subroutine lw_lw_split