subroutine qinit(maxmx,meqn,mbc,mx,x_low,dx,q,maux,aux)

    implicit none

    !==== Variables ====
    
    !---- Input ----
    integer, intent(in) :: maxmx, meqn, mbc, mx, maux
    double precision :: x_low, dx, aux
    
    !---- Output ----
    double precision, intent(out) :: q(1-mbc:mx+mbc,meqn)

    
    !---- Local ----
    double precision :: x, q_true
    integer :: i
    
    
    do i = 1,mx
        x      = x_low + (i-0.5d0)*dx
        q(i,1) = q_true(x, 0.d0)
    end do

end subroutine qinit



function q_true(x, t)
    implicit none
    double precision, intent(in) :: x, t
    double precision :: q_true, pi=acos(-1.d0), t0=.5d0
    double precision :: velocity, diffusivity
    common /param_block/ velocity, diffusivity
    
    q_true = 1.d0/sqrt(4.d0*pi*diffusivity*(t+t0)) * exp(-(x-velocity*t)**2 / (4.d0*diffusivity*(t+t0)))

!     q_true = exp( -200.d0*(x-velocity*t)**2 )

end function q_true



