subroutine src1(maxmx, meqn, mbc, mx, x_low, dx, q, maux, aux, t, dt)

    implicit none

    !==== Variables ====

    !---- Inputs ----
    integer, intent(in) :: maxmx, meqn, mbc, mx, maux
    double precision, intent(in) :: x_low, dx, t, dt
    double precision, intent(in) :: aux(1-mbc:mx+mbc, maux)

    !---- Input/output ----
    double precision, intent(inout) :: q(1-mbc:maxmx+mbc, meqn)

    !---- Globals ----
    integer :: split_order
    double precision :: velocity, diffusivity
    common /param_block/ velocity, diffusivity, split_order

    !---- Functions ----
    double precision :: q_true

    !---- Locals ----
    double precision :: x_coordinate, new_bcs(2), final_bcs(2), mod_bcs(2)
    double precision :: t_old, t_new, q_left_mod, q_right_mod
    integer :: ix


    !==== Statement functions ====
    x_coordinate(ix) = x_low + (ix-.5d0)*dx


    t_old = t-dt
    t_new = t



    !---- Set old and new boundary data ----

    q(0,1)    = q_true( x_coordinate(0),    t_old )
    q(mx+1,1) = q_true( x_coordinate(mx+1), t_old )

    final_bcs(1) = q_true( x_coordinate(0),    t_new )
    final_bcs(2) = q_true( x_coordinate(mx+1), t_new )
    
    
    if (split_order==1) then
        call lw_cn_split( q(0:mx+1,1), final_bcs, velocity, diffusivity, dx, dt, mx )
    else if (split_order==2) then
        call cn_lw_split( q(0:mx+1,1), final_bcs, velocity, diffusivity, dx, dt, mx )
    else
        print *, "Must set split_order=1 or 2."
        stop
    end if
        
              
end subroutine src1