from SimulationData import *
from numpy import *
from pylab import *
import os


os.system( "make" )


mx_base = 40



def dtRefinementTest( dt_values, diffusivity ):

    n_runs = len(dt_values)

    error_values = zeros( n_runs )
    

    sim_data = SimulationData()
    sim_data.t_limits = (0.,.5)
    sim_data.x_low = (-.5, -1., 0.)
    sim_data.x_high = (1., 1., 1.)
    sim_data.diffusivity = diffusivity


    for i_run in range( len(dt_values) ):

        dt = dt_values[i_run]
        mx = int( dt_values[0]/dt * mx_base )

        sim_data.dt = dt
        sim_data.n_cells = (mx,mx,mx)
        print sim_data.n_cells
    
        sim_data.writeDataFile()
    
        os.system( "./dimension_splitting_3d" )
    
        error_file = open( "NumericalError.txt", "r" )
        error_values[i_run] = float( error_file.readline() )
        error_file.close()

    return error_values




dt_values = .1 * logspace(0,-1,11)
# error_values = dtRefinementTest( dt_values, .1 )



plot_parameters = {'backend': 'eps',
          'lines.linewidth': 4,
          'lines.markersize': 6,
          'text.fontsize': 10,
          'font.size'    : 10,
          'legend.fontsize': 10,
          'xtick.labelsize': 10,
          'ytick.labelsize': 10,
          'axes.labelsize':  14,
          'figure.subplot.left':   0.18,
          'figure.subplot.right':  0.95,
          'figure.subplot.bottom': 0.15,
          'figure.subplot.top':    0.9}

rcParams.update(plot_parameters)


figure(figsize=(4,3), facecolor='w', edgecolor='k')



#---- Produce error plots ----
clf()
loglog(dt_values, error_values, 'ko', label="Error values")


loglog(dt_values, dt_values**2, 'k-', label="$\Delta t^2$")

legend(loc='upper left')
xlabel('$\Delta t$')
xlim(.8e-2,1.2e-1)