from numpy import *
from StabilityTesters import *
from pylab import *




courant_values = linspace(0., 1.0, 51)
diff_ratios    = logspace(-1, 4, 51)
C, D = meshgrid( courant_values, diff_ratios )


CNAdvDiff = CNAdvDiffStabilityTester( courant_values, diff_ratios )


# clf()
plot_parameters = {'backend': 'eps',
          'lines.linewidth': 4,
          'lines.markersize': 4,
          'text.fontsize': 10,
          'font.size'    : 10,
          'legend.fontsize': 10,
          'xtick.labelsize': 10,
          'ytick.labelsize': 10,
          'axes.labelsize':  14,
          'figure.subplot.left':   0.18,
          'figure.subplot.right':  0.95,
          'figure.subplot.bottom': 0.15,
          'figure.subplot.top':    0.9}

rcParams.update(plot_parameters)

figure(figsize=(4,3), facecolor='w', edgecolor='k')




contour_values = array([.98, .99, .995, .999, .9999  ])
c = contour( C, D, CNAdvDiff.max_eigenvalues, contour_values, colors='k', linewidths=3 )

yscale('log')
clabel(c, inline=True, fmt='%1.4f')


xlabel("$\\nu$")
ylabel("$\sigma$")

title("Crank-Nicolson")


