from numpy import *
from StabilityTesters import *
from pylab import *



        





mx_values   = array( linspace(10,200,51).round(), dtype='int' )
stab_values = logspace(-1,4,51)
M, S = meshgrid( mx_values, stab_values )


CN    = CrankNicolsonStabilityTester( mx_values, stab_values )
CNFwd = CrankNicolsonForwardStabilityTester( mx_values, stab_values )




plot_parameters = {'backend': 'eps',
          'lines.linewidth': 2,
          'lines.markersize': 4,
          'text.fontsize': 10,
          'font.size'    : 10,
          'legend.fontsize': 10,
          'xtick.labelsize': 10,
          'ytick.labelsize': 10,
          'axes.labelsize':  14,
          'figure.subplot.left':   0.15,
          'figure.subplot.right':  0.95,
          'figure.subplot.bottom': 0.18,
          'figure.subplot.top':    0.9}

rcParams.update(plot_parameters)




# contour_values = array([1., 1.4, 1.8, 2.2, 2.6, 2.9])
# contour_values = array([.99, .999, 1., 1.2, 1.4, 1.6, 1.8, 2., 2.3, 2.6, 2.9])


figure(figsize=(4,3), facecolor='w', edgecolor='k')
contour_values = array([.92, .96, .98, .995, .999])
cn_contours = contour( M, S, CN.max_eigenvalues, contour_values, colors='k', linewidths=4 )
# xscale('log')
yscale('log')
clabel(cn_contours, inline=True)
xlabel('# grid points')
ylabel('$\sigma$')
title('Unmodified Crank-Nicolson')


figure(figsize=(4,3), facecolor='w', edgecolor='k')
contour_values = array([1., 1.5, 2., 2.5, 2.9, 2.99])
cnfwd_contours = contour( M, S, CNFwd.max_eigenvalues, contour_values, colors='k', linewidths=4 )
# xscale('log')
yscale('log')
clabel(cnfwd_contours, inline=True)
xlabel('# grid points')
title('C.N. with forward estimation')
ylabel('$\sigma$')
