from numpy import *
from StabilityTesters import *
from pylab import *




courant_values = linspace(0., 1.2, 51)
diff_ratios    = logspace(-1, 4, 51)
C, D = meshgrid( courant_values, diff_ratios )


# LWAdvDiff = LWAdvDiffStabilityTester( courant_values, diff_ratios )



plot_parameters = {'backend': 'eps',
          'lines.linewidth': 4,
          'lines.markersize': 4,
          'text.fontsize': 10,
          'font.size'    : 10,
          'legend.fontsize': 10,
          'xtick.labelsize': 10,
          'ytick.labelsize': 10,
          'axes.labelsize':  14,
          'figure.subplot.left':   0.18,
          'figure.subplot.right':  0.95,
          'figure.subplot.bottom': 0.15,
          'figure.subplot.top':    0.9}

rcParams.update(plot_parameters)

figure(figsize=(4,3), facecolor='w', edgecolor='k')




contour_values = array([.8, .9, .95, .99, .999, .9999])
c = contour( C, D, LWAdvDiff.max_eigenvalues, contour_values, colors='k', linewidths=3 )

yscale('log')

contour_labels = {}
for val in contour_values:
    contour_labels[val] = str(val)

clabel( c, inline=True, fmt=contour_labels )
xlim(0.,1.1)

xlabel("$\\nu$")
ylabel("$\sigma$")

title("Lax-Wendroff")

