from numpy import *
from StabilityTesters import *
from pylab import *




mx_values     = array( linspace(10, 200 ,31).round(), dtype='int' )
courant_values = linspace(.5, 1.2, 31)
M, C = meshgrid( mx_values, courant_values )


LWBackEst = LaxWendroffBackwardEstimate( mx_values, courant_values )


def criticalCourant( max_eigs ):
    
    critical_values = zeros( shape(max_eigs)[1] )
    
    for j in range( shape(max_eigs)[1] ):
        idx, = where( max_eigs[:,j] > 1. )
        idx = idx.min()
        b = max_eigs[idx,j]
        a = max_eigs[idx-1,j]
        frac = (1.-a) / (b-a)

        critical_values[j] = courant_values[idx-1] + frac*(courant_values[idx] - courant_values[idx-1])
        
    return critical_values




plot_parameters = {'backend': 'eps',
          'lines.linewidth': 4,
          'lines.markersize': 4,
          'text.fontsize': 10,
          'font.size'    : 10,
          'legend.fontsize': 10,
          'xtick.labelsize': 10,
          'ytick.labelsize': 10,
          'axes.labelsize':  14,
          'figure.subplot.left':   0.18,
          'figure.subplot.right':  0.95,
          'figure.subplot.bottom': 0.15,
          'figure.subplot.top':    0.9}

rcParams.update(plot_parameters)

figure(figsize=(4,3), facecolor='w', edgecolor='k')

plot( mx_values, criticalCourant(LWBackEst.max_eigenvalues), 'k' )

title('LW with backward estimation')
# legend()


ylim(.6,1.4)
yticks( arange(.6,1.41,.2) )

xlabel("# grid points")
ylabel("Critical Courant number")



