subroutine qinit(maxmx,meqn,mbc,mx,x_low,dx,q,maux,aux)

    implicit none

    !==== Variables ====
    
    !---- Input ----
    integer, intent(in) :: maxmx, meqn, mbc, mx, maux
    double precision :: x_low, dx, aux
    
    !---- Output ----
    double precision, intent(out) :: q(1-mbc:mx+mbc,meqn)

    
    !---- Local ----
    double precision :: x, q_true
    integer :: i
    
    
    do i = 1,mx
        x      = x_low + (i-0.5d0)*dx
        q(i,1) = q_true(x, 0.d0)
    end do

end subroutine qinit



function q_true(x, t)
    implicit none
    double precision, intent(in) :: x, t
    double precision :: q_true
    
    q_true = exp(-x**2 - t)
!     q_true = exp( - (x-.5d0*t)**2 )

end function q_true



function velocity_function(x)
    implicit none
    double precision, intent(in) :: x
    double precision :: velocity_function, diffusivity
    common /param_block/ diffusivity
    
    velocity_function = (diffusivity*(4*x**2 - 2.d0) + 1.d0) / (-2*x)

end function velocity_function