subroutine src1(maxmx, meqn, mbc, mx, x_low, dx, q, maux, aux, t, dt)

    implicit none

    !==== Variables ====

    !---- Inputs ----
    integer, intent(in) :: maxmx, meqn, mbc, mx, maux
    double precision, intent(in) :: x_low, dx, t, dt
    double precision, intent(in) :: aux(1-mbc:mx+mbc, maux)

    !---- Input/output ----
    double precision, intent(inout) :: q(1-mbc:maxmx+mbc, meqn)

    !---- Globals ----
    integer :: split_type
    double precision :: diffusivity
    common /param_block/ diffusivity, split_type

    !---- Functions ----
    double precision :: q_true

    !---- Locals ----
    double precision :: x_coordinate, new_bcs(2), final_bcs(2), q_alt(0:mx+1), lw_diffusivity
    double precision :: t_old, t_new
    integer :: ix


    !==== Statement functions ====
    x_coordinate(ix) = x_low + (ix-.5d0)*dx


    !---- Alias time values ----
    
    t_old = t-dt
    t_new = t



    !---- Set boundary data ----
    
    q(0,1)    = q_true( x_coordinate(0),    t_old )
    q(mx+1,1) = q_true( x_coordinate(mx+1), t_old )
    
    final_bcs(1) = q_true( x_coordinate(0),    t_new )
    final_bcs(2) = q_true( x_coordinate(mx+1), t_new )



    !---- Advance ----
    
    if (split_type==1) then
        call lw_cn_lw_split( q(0:mx+1,1), final_bcs, aux(0:mx+1,1), diffusivity, dx, dt, mx )
    else if (split_type==2) then
        call cn_lw_cn_split( q(0:mx+1,1), final_bcs, aux(0:mx+1,1), diffusivity, dx, dt, mx )
    else
        print *, "Must set split_type=1 or 2."
        stop
    end if

        
              
end subroutine src1